Subject: Re: bug#9406: 24.0.50; Use M-p/M-n to navigate through the kill ring

From: Dani Moncayo <[email-masked]>
Date: Wed, 31 Aug 2011 12:45:20 +0200

Hi Juri,

On Wed, Aug 31, 2011 at 11:51, Juri Linkov <[email-masked]> wrote:
>> Using the minibuffer would be indeed a way of doing this, but on
>> second thought I think that it would be better to have "in-site"
>> replacement of the yanked text (like M-y does now), because:
>>
>> 1. It would be quicker: It saves you the extra <RET> once you have
>> selected the wanted entry.
>
> "In-situ" replacement is quicker indeed but has its own problems:
> to undo the last yanked text to the initial state you have to undo
> insertions and deletions of all intermediate elements of the kill ring.
>
> So what you propose is like setting `search-ring-update' to t in Isearch.
> It's quicker without requiring <RET>, but to revert to the initial search
> position you have to undo all search movements for intermediate elements of
> the search ring.

Correct.  That is the way M-y works now, so that this would not be a
new problem.  Besides, that problem is quite minor, IMO, because:
* The common case would be to yank the last or close-to-last entry
from the ring, so that no (or very few) extra "undo" movements would
be necessary.
* In the rare cases of yanking and old entry *and* then wanting to
revert it, users would always have the quick option of deleting the
region (which as you now is updated in every yank operation).

So, i think that the drawbacks are much smaller than the advantages.

>> 2. When the killed text is tall (has many lines), the minibuffer would
>> show only a small fragment of it.
>
> The minibuffer shows enough multi-line text to recognize the wanted entry.

Yes, I also think so.  So this point would make little difference, but
anyway large entries would be shown even better in the buffer, because
there would be normally more visual space.

>> Thus, for example if you wanted to yank the third entry from the kill
>> ring, all you would have to to is "C-y M-p M-p M-p" and you're done.
>> Very quick, very intuitive, very convenient!
>
> With many M-p, one extra <RET> is not a problem.

As I've said above, I think that the common case would imply one or
very few "M-p"'s.  Besides, typing 2 or 3 times the same key is almost
as quick as typing it only once.  Therefore, IMO the extra <RET> would
really make a difference.

-- 
Dani Moncayo